<?php

// all page come from here

class cpgHTML {
// -----------------------------------------------------------------------------------------
// VIEW CART
// ----------------------------------------------------------------------------------------- 
	function view_cart() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_view_cart;
		global $cpgmart;        
		if (!is_object($cpgmart)) $cpgmart = new cpgMart();	
	    $task = cpgTool::request_var('task');
	    //$message   	   = cpgTemplate::get('element_message');
	    $tpl_view_cart = cpgTemplate::get('blog_view_cart');
	    $cart_header   = cpgTemplate::extract($tpl_view_cart, 'cart_header');
	    $cart_element  = cpgTemplate::extract($tpl_view_cart, 'cart_element');
	    $cart_footer   = cpgTemplate::extract($tpl_view_cart, 'cart_footer');	    
	    switch ($task) { 
	    	// update cart
	    	case "add_item":
	    		// pid
	    		$pid = (int)cpgTool::post_var("id");    		
	    		// get cart option == little tricky	    		
	    	    $option_array = cpgTool::get_option_array_from_pid($pid);
	    	    $option = array();
	    	    foreach ($option_array as $option_id) {
	    	    	$option[$option_id] = cpgTool::post_var("option_".$option_id);	
				}                                                   				
	    		// vars    	    	
	    		$cpgmart->add_item(array(
	    			'pid'	 =>	$pid,	
	    		    'price'	 =>	cpgTool::post_var("price"),
	    		    'option' =>	$option,
	    		    'qty' 	=>	1,
	    		));
	    		$cpgmart->save();	    		
	    		break;
			case "edit":										
			    // update cart 			    
			    foreach ($_POST as $name => $value) {
					if (cpgTool::in_string($name, "price_")) {							
						$item_pos = (int)str_replace("price_", "", $name);
						if (cpgTool::post_var("item_".$item_pos) == 'on') {
							// remove	
							$cpgmart->remove_item($item_pos);							
						} else {
							// update
							$current_item_data['pid'] = (int)cpgTool::post_var("pid_".$item_pos);
							$current_item_data['price'] = cpgTool::post_var("price_".$item_pos);
							$current_item_data['qty'] = cpgTool::post_var("qty_".$item_pos);
							$option_array = cpgTool::get_option_array_from_pid((int)cpgTool::post_var("pid_".$item_pos));
	    	    			$current_item_data['option'] = array();
	    	    			foreach ($option_array as $option_id) {
	    	    				$current_item_data['option'][$option_id] = cpgTool::post_var("option_".$option_id."_".$item_pos);	
							}       
							$cpgmart->edit_item($item_pos, $current_item_data);							
						}
					} 
				}				
				// save ^^ 				
			    $cpgmart->save();
				break;			
		}
		// view cart
		starttable('-1', 'VIEW CART', 7);
		// cart header
		echo cpgTemplate::set($cart_header, array(
			'{LANG_HOME_PAGE}'	  => "RETURN TO HQ",
			'{LANG_DEL}'          => "DELETE",	
			'{LANG_THUMB}'        => "THUMB",	
			'{LANG_NAME}'         => "ITEM NAME",
			'{LANG_PRICE_OPTION}' => "PRICE & OPTION",
			'{LANG_PRICE_EACH}'   => "PRICE PER ONE",
			'{LANG_QTY}'          => "QTY",
			'{LANG_PRICE_ALL}'    => "TOTAL",		
		));     		
		// cart body
		$total = 0;		
		foreach ($cpgmart->cart as $item_pos => $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);			
			$price_each = cpgTool::price_each($item_data);  			
			$total += $price_each * $item_data['qty'];
			$vars = array(
				'{PID}'			=> HTMLelement::hidden("pid_".$item_pos, $item_data['pid']),
				'{CHECK_BOX}'	=> HTMLelement::check_box("item_".$item_pos),
				'{THUMB}'		=> HTMLelement::image(get_pic_url($CURRENT_PIC_DATA, "thumb")),
				'{NAME}'		=> HTMLelement::item_name($CURRENT_PIC_DATA),
				'{PRICE}'		=> HTMLelement::price_list($CURRENT_PIC_DATA['price'], $item_data['price'], "_".$item_pos),
				'{OPTION}'		=> HTMLelement::option_list($CURRENT_PIC_DATA['option'], $item_data['option'], "_".$item_pos),
				'{PRICE_EACH}'	=> $currency_symbol[$CONFIG['cpgmart_currency']] ." ".cpgTool::price_format($price_each),
				'{QTY}'			=> HTMLelement::qty_input("qty_".$item_pos, $item_data['qty']),
				'{PRICE_ALL}'	=> $currency_symbol[$CONFIG['cpgmart_currency']] ." ".cpgTool::price_format($item_data['qty'] * $price_each),
			);
		    echo cpgTemplate::set($cart_element, $vars);		
		}
		// shipping fee + tax fee + ..		
		// cart_footer
		echo cpgTemplate::set($cart_footer, array(
			'{LANG_PRICE_TOTAL}'	=>	"TOTAL",
			'{PRICE_TOTAL}'         =>	$currency_symbol[$CONFIG['cpgmart_currency']] ." ". cpgTool::price_format($total),
			'{LANG_SUBMIT}'         =>	"EDIT CART",
			'{LANG_CHECK_OUT}'		=>	"CHECK OUT",
		));
		
		endtable();		
	}
// -----------------------------------------------------------------------------------------
// PREVIEW CART + PAYMENT CHOOSE
// ----------------------------------------------------------------------------------------- 
	function preview_cart() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_preview_cart;
		global $cpgmart;
		if (!is_object($cpgmart)) $cpgmart = new cpgMart();	
		$task = cpgTool::request_var('task');
		$tpl_preview_cart = cpgTemplate::get('blog_preview_cart');	   
	    $payment_gateway  = cpgTemplate::extract($tpl_preview_cart, 'payment_gateway');
		// view cart in plain format
		starttable('-1', 'PREVIEW CART', 6);		
		HTMLelement::preview_cart($cpgmart->cart);		
		endtable();
		HTMLelement::spacer();
		starttable('-1');
		echo cpgTemplate::set($payment_gateway, array(
			'{LANG_PAYMENT_GATEWAY}' => "Pay by",	
			'{PAYMENT_GATEWAY}'		 =>	HTMLelement::simple_select('payment_gateway', array('paypal'=>'PayPal'),'paypal'),
			'{LANG_SUBMIT}'          =>	"CHECK OUT",  
		));
		endtable();		
	}
// -----------------------------------------------------------------------------------------
// CHECK OUT
// ----------------------------------------------------------------------------------------- 
	function check_out() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_check_out;
		global $cpgmart;
		if (!is_object($cpgmart)) $cpgmart = new cpgMart();
	    $task = cpgTool::request_var('task');	
	    $tpl_check_out = cpgTemplate::get('blog_check_out');
	    $form_header   = cpgTemplate::extract($tpl_check_out, 'form_header'); 	    
	    $form_footer   = cpgTemplate::extract($tpl_check_out, 'form_footer'); 
		// view cart in plain format 
		starttable('-1', 'CART DATA', 6);		
		HTMLelement::preview_cart($cpgmart->cart);
		endtable();
		HTMLelement::spacer();		
		// real || sand box
		if ($CONFIG['cpgmart_test_mode'])
			$paypal_address = "https://www.sandbox.paypal.com/cgi-bin/webscr";
		else
			$paypal_address = "https://www.paypal.com/cgi-bin/webscr";
		// checkout button or smt
		starttable('-1');
		echo cpgTemplate::set($form_header, array(
			'{SITE_URL}'		=>	$CONFIG['ecards_more_pic_target'],
			'{PAYPAL_ADDRESS}'	=>	$paypal_address,
			'{ACCOUNT}'			=>	$CONFIG['cpgmart_pp_account'],
		    '{CURRENCY}'    	=>  $CONFIG['cpgmart_currency'],
		));		
		$item_pos = 0;
		foreach ($cpgmart->cart as $item_data) {				
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
			$item_pos++;
			// main
			echo HTMLelement::hidden("item_name_".$item_pos, HTMLelement::item_name($CURRENT_PIC_DATA));
			echo HTMLelement::hidden("amount_".$item_pos, cpgTool::price_format(cpgTool::price_each($item_data)));
			echo HTMLelement::hidden("quantity_".$item_pos, $item_data['qty']);
			echo HTMLelement::hidden("item_number_".$item_pos, $item_pos);
			// show option
			$option_pos = 0;
			foreach ($item_data['option'] as $option_id => $option_value) {
				//echo HTMLelement::hidden("on".$option_pos."_".$item_pos, $item_data['qty']); 	
				//echo HTMLelement::hidden("os".$option_pos."_".$item_pos, $item_data['qty']);
				$option_pos++;
			}			
		}
		echo cpgTemplate::set($form_footer, array(
			'{SITE_URL}'	=>	$CONFIG['ecards_more_pic_target'],						
		    '{LANG_SUBMIT}' =>	'CLICK TO PAY',
		));
		endtable();		
	}	
// -----------------------------------------------------------------------------------------
// CONFIG
// ----------------------------------------------------------------------------------------- 
	function config() {
		global $CONFIG;
		global $currency_symbol;
		$task = cpgTool::request_var('task');
		$tpl_config = cpgTemplate::get('blog_config');		
		$message    = cpgTemplate::get('element_message');
		if ($task == 'edit') {			
			$cpgmart_enable = (int)cpgTool::post_var('cpgmart_enable');
			cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CONFIG']}` SET value='$cpgmart_enable' WHERE name='cpgmart_enable' LIMIT 1;");
			$cpgmart_currency = cpgTool::post_var('cpgmart_currency');
			cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CONFIG']}` SET value='$cpgmart_currency' WHERE name='cpgmart_currency' LIMIT 1;");
			$cpgmart_pp_account = cpgTool::post_var('cpgmart_pp_account');
			cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CONFIG']}` SET value='$cpgmart_pp_account' WHERE name='cpgmart_pp_account' LIMIT 1;");
			$cpgmart_test_mode = (int)cpgTool::post_var('cpgmart_test_mode');
			cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CONFIG']}` SET value='$cpgmart_test_mode' WHERE name='cpgmart_test_mode' LIMIT 1;");
			
			starttable('-1', 'MESSAGE');
			echo cpgTemplate::set($message, array(
				'{MESSAGE}'	=>	'EDIT CONFIG SUCCESSFUL !',
			));
			endtable();			
			// update for display
			$CONFIG['cpgmart_enable']	  = $cpgmart_enable;
			$CONFIG['cpgmart_currency']   = $cpgmart_currency;
			$CONFIG['cpgmart_pp_account'] = $cpgmart_pp_account;
			$CONFIG['cpgmart_test_mode']  = $cpgmart_test_mode;
		}
		HTMLelement::spacer();
		starttable(-1, 'CPGMART CONFIG', 2);
		$vars = array(
			'{LANG_ENABLE}'		=>	"ENABLE THE PLUGIN",
			'{ENABLE}'			=>	HTMLelement::radio('cpgmart_enable', $CONFIG['cpgmart_enable']),
			'{LANG_CURRENCY}'	=>	"DEFAULT CURRENCY",
		    '{CURRENCY}'		=>	HTMLelement::simple_select("cpgmart_currency", $currency_symbol, $CONFIG['cpgmart_currency']),
		    '{LANG_PP_ACCOUNT}' =>	'PAYPAL ACCOUNT',
		    '{PP_ACCOUNT}'      =>  HTMLelement::text_input('cpgmart_pp_account', $CONFIG['cpgmart_pp_account']),
		    '{LANG_TEST_MODE}'  =>	'TEST MODE',
		    '{TEST_MODE}'       =>  HTMLelement::radio('cpgmart_test_mode', $CONFIG['cpgmart_test_mode']),
		    '{LANG_SUMBIT}'		=>	"EDIT",
		    '{LANG_RESET}'		=>	"RESET",
		);
		echo cpgTemplate::set($tpl_config, $vars);		
		endtable();
	}
// -----------------------------------------------------------------------------------------
// MAIN PAGE
// -----------------------------------------------------------------------------------------		
	function mainpage() {
		global $CONFIG;	
		$tpl_atc = cpgTemplate::get('blog_main_page');		
		$number_of_price     = cpgDB::fetchVar("SELECT count(*) FROM `{$CONFIG['TABLE_CM_PRICE']}`;");
		$number_of_priceset  = cpgDB::fetchVar("SELECT count(*) FROM `{$CONFIG['TABLE_CM_PRICESET']}`;");
		$number_of_option    = cpgDB::fetchVar("SELECT count(*) FROM `{$CONFIG['TABLE_CM_OPTION']}`;");
		$number_of_optionset = cpgDB::fetchVar("SELECT count(*) FROM `{$CONFIG['TABLE_CM_OPTIONSET']}`;");
		$number_of_order     = cpgDB::fetchVar("SELECT count(*) FROM `{$CONFIG['TABLE_CM_ORDER']}`;");
		starttable('-1', "MAIN PAGE", 2);
	   	echo cpgTemplate::set($tpl_atc, array(
	   		'{STASTICS}' => "STASTICS",
	   		'{LANG_1}'	 => "NUMBER OF PRICE",
	   		'{1}' 		 => $number_of_price,
	   		'{LANG_2}'	 => "NUMBER OF PRICE SET",
	   		'{2}' 		 => $number_of_priceset,
	   		'{LANG_3}'	 => "NUMBER OF OPTION",
	   		'{3}' 		 => $number_of_option,
	   		'{LANG_4}'	 => "NUMBER OF SET",
	   		'{4}' 		 => $number_of_optionset,
	   		'{LANG_5}'	 => "NUMBER OF ORDER",
	   		'{5}' 		 => $number_of_order,
	   	));
		endtable();
	}
// -----------------------------------------------------------------------------------------
// DOCUMENTS
// -----------------------------------------------------------------------------------------	
	function documents() {
		starttable('-1','Documments');
		$tpl_documents = cpgTemplate::get('blog_simple_data');
		$vars = array(
			'{TEXT}'=>'Hello World - Documments ^^ !',
		);		
		echo cpgTemplate::set($tpl_documents, $vars);
		endtable();	
	}
// -----------------------------------------------------------------------------------------
// ABOUTS
// -----------------------------------------------------------------------------------------	
	function abouts() {	
		starttable('-1','Abouts');
		$tpl_about = cpgTemplate::get('blog_simple_data');
		$vars = array(
			'{TEXT}'=>'Hello World - Abouts ^^ !',
		);		
		echo cpgTemplate::set($tpl_about, $vars);
		endtable();
	}
// -----------------------------------------------------------------------------------------
// ADD TO CART BUTTON
// -----------------------------------------------------------------------------------------	
	function add_to_cart($CURRENT_PIC_DATA) {
		if ((int)$CURRENT_PIC_DATA['price'] == 0) return "";
		$tpl_atc = cpgTemplate::get('blog_add_to_cart');
		if ((int)$CURRENT_PIC_DATA['option'] == 0) 
			cpgTemplate::extract($tpl_atc, 'option');		
		$vars = array(
			'{ID}'			 =>	$CURRENT_PIC_DATA['pid'],
			'{PRICE_TITLE}'	 =>	HTMLelement::price_list_title($CURRENT_PIC_DATA['price']),
			'{PRICE}'		 =>	HTMLelement::price_list($CURRENT_PIC_DATA['price']),
			'{OPTION_TITLE}' =>	HTMLelement::option_list_title($CURRENT_PIC_DATA['option']),
		    '{OPTION}'		 =>	HTMLelement::option_list($CURRENT_PIC_DATA['option']),  
		    '{LANG_TITLE}'	 =>	'CPGMART',
		    '{LANG_SUBMIT}'	 =>	'ADD TO CART',
		);
		return cpgTemplate::set($tpl_atc, $vars);
	}

// -----------------------------------------------------------------------------------------
// ORDER MANAGER
// ----------------------------------------------------------------------------------------- 
	function order() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_option_set_manager;
		global $log_date_fmt;	
		// get ACTION		
		$task = cpgTool::request_var('task');		
		// TEMPLATE  
		$message        = cpgTemplate::get('element_message'); 
		$tpl_order      = cpgTemplate::get('blog_order');		
		$order_title    = cpgTemplate::extract($tpl_order, 'order_title');
		$order_element  = cpgTemplate::extract($tpl_order, 'order_element');
	    // task -> action
		switch ($task) {
			case 'view_act':				
				$oid = (int)cpgTool::get_var('oid');				
				$cart_data = cpgDB::fetchVar("SELECT cart FROM `{$CONFIG['TABLE_CM_ORDER']}` WHERE oid = '$oid';"); 
				if ($cart_data) {
					$cart_data = cpgTool::decode_data($cart_data);					
					starttable('-1', "ORDER DETAILS", 6);
			    	HTMLelement::preview_cart($cart_data);     			
					endtable();							
					HTMLelement::spacer();
				}
				break;
		}
		// main
		starttable('-1', "ORDER LIST", 6);
		echo cpgTemplate::set($order_title, array(
			'{LANG_NUMBER}' => "ORDER NUMBER",  	
			'{LANG_TXN_ID}' => "TXN ID",
			'{LANG_TIME}'   => "TIME",  	  	
			'{LANG_METHOD}' => "METHOD",  	
			'{LANG_AMOUNT}' => "AMOUNT",  	
			'{LANG_STATUS}' => "STATUS",				
		));
		$order_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_ORDER']}`;");
		foreach ($order_array as $order) {	
			$log_data = cpgTool::decode_data($order['log']);
			echo cpgTemplate::set($order_element, array(
				'{NUMBER}' => HTMLelement::link("index.php?file=cpgmart/cpgmart_config&page=order&task=view_act&oid=".$order['oid'],"#".$order['oid']),
				'{TXN_ID}' => $order['txnid'],
				'{TIME}'   => localised_date($order['time'], $log_date_fmt),  	  	
				'{METHOD}' => $order['method'],  					
				'{AMOUNT}' => $currency_symbol[$log_data['mc_currency']]." ".$log_data['payment_gross'],
				'{STATUS}' => $order['status'],		
			));		
		}
		endtable();				
	}	
// -----------------------------------------------------------------------------------------
// OPTION SET MANAGER
// ----------------------------------------------------------------------------------------- 
	function option_set() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_option_set_manager;
	    // get ACTION		
		$task = cpgTool::request_var('task');		
		// TEMPLATE  
		$tpl_option_set = cpgTemplate::get('blog_option_set');
		$title     = cpgTemplate::extract($tpl_option_set, 'title');
		$element   = cpgTemplate::extract($tpl_option_set, 'element');
		$element_m = str_replace('tableb', 'tableh2', $element);
		$page_nav  = cpgTemplate::extract($tpl_option_set, 'page_nav');
		$control   = cpgTemplate::extract($tpl_option_set, 'control');
		$aoe 	   = cpgTemplate::extract($tpl_option_set, 'aoe');
		$message   = cpgTemplate::get('element_message'); 
	    // task -> action
		switch ($task) {
	    	case 'new':
	    		// get a price list
	    		$rowset = cpgDB::fetchRowset("SELECT oid, title FROM `{$CONFIG['TABLE_CM_OPTION']}` ORDER BY title ASC;");
	    		$option_array = array();
	    		foreach ($rowset as $row) {
	    			$option_array[$row['oid']]	= $row['title'];	    			
				}	    	
	    		// vars
	    		$vars = array(
	    			'{GB_TITLE}'		=>	"ADD NEW OPTION SET",
					'{ID}'				=>	"",
					'{TASK}'			=>	"new_act",
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title",""),
					'{LANG_OPTION_SET}'	=>	"OPTION SET",
					'{OPTION_SET}'		=>	HTMLelement::multiple_select('option_set', $option_array),
					'{LANG_SUBMIT}'		=>	'ADD',
					'{LANG_RESET}'		=>	'RESET',
	    		);
	    		echo cpgTemplate::set($aoe, $vars);
	    		HTMLelement::spacer();		    	
	    		break;
	    	case 'new_act':
	    	    $title = addslashes(cpgTool::post_var('title'));
	    	    $option_set = cpgTool::encode_data(cpgTool::post_var('option_set'));
	    	    $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CM_OPTIONSET']}` (oid, title, option_array) VALUES ('', '$title', '$option_set');");
				$markup_element_id = cpgDB::insertID();
				// success message 
				starttable('-1', 'MESSAGE');
				echo cpgTemplate::set($message, array('{MESSAGE}'	=>	"ADD OPTION SET <b><u>$title</u></b> SUCESSFUL !"));
				endtable();
				HTMLelement::spacer();     
	    		break;	
	    	case 'edit':
	    		$id = (int)cpgTool::get_var('id');
	    		$current_option_set_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` WHERE oid='$id';");	    		
	    		$current_option_array = cpgTool::decode_data($current_option_set_data['option_array']);	    		
	    		// get a price list
	    		$rowset = cpgDB::fetchRowset("SELECT oid, title FROM `{$CONFIG['TABLE_CM_OPTION']}` ORDER BY title ASC;");
	    		$option_array = array();
	    		$default_array = array();
	    		foreach ($rowset as $row) {
	    			$option_array[$row['oid']]	= $row['title'];
	    			if (in_array($row['oid'], $current_option_array)) $default_array[] = $row['oid'];	    			
				}	    	
	    		// vars
	    		$vars = array(
	    			'{GB_TITLE}'		=>	"EDIT A OPTION SET",
					'{ID}'				=>	$id,
					'{TASK}'			=>	"edit_act",
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title", $current_option_set_data['title']),
					'{LANG_OPTION_SET}'	=>	"OPTION SET",
					'{OPTION_SET}'		=>	HTMLelement::multiple_select('option_set', $option_array, $default_array),
					'{LANG_SUBMIT}'		=>	'EDIT',
					'{LANG_RESET}'		=>	'RESET',
	    		);
	    	    echo cpgTemplate::set($aoe, $vars);
	    		HTMLelement::spacer();	
	    		break;
	    	case 'edit_act':
	    		$id = (int)cpgTool::post_var('id');
	    		$title = addslashes(cpgTool::post_var('title'));
	    	    $option_set = cpgTool::encode_data(cpgTool::post_var('option_set'));
	    	    $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CM_OPTIONSET']}` SET title='$title', option_array='$option_set' WHERE oid = '$id';");
				$markup_element_id = $id;
				// success message 
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, array('{MESSAGE}'	=>	"EDIT OPTION SET <b><u>$title</u></b> SUCESSFUL !"));
				endtable();
				HTMLelement::spacer();     
	    		break;	
	    		break;	
	    	case 'del_act':
	    		// which one will be delete
				foreach ($_POST as $name => $value) {
					if (cpgTool::in_string($name, "item_")) {
						$delete_id = (int)str_replace("item_", "", $name);
						if ($delete_id != 0 && $value == 'on') 
							$delete_list[] = $delete_id;
					}			
				}				
				// delete
				// success message  					
				starttable('-1', 'MESSAGE');
				foreach ($delete_list as $delete_id) {
					cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` WHERE oid = '$delete_id' LIMIT 1;");
					$vars = array('{MESSAGE}'	=>	"OPTION SET ID <b><u>$delete_id</u></b> DELETE SUCCESSFUL !");
					echo cpgTemplate::set($message, $vars);
				}                                       				
				endtable();
				HTMLelement::spacer();	
				break;	
		}
		// main page
		starttable('-1', 'OPTION SET LIST', 3);
		// control box
		echo cpgTemplate::set($control, array(
			'{LANG_NEW}'	=>	"NEW OPTION SET",
			'{LANG_DEL}'	=>	"DEL OPTION SET",
		));		
		// title
		echo cpgTemplate::set($title, array(
			'{LANG_TITLE}'		=>	"SET NAME",
			'{LANG_OPTION_SET}' =>	"SET DATA",		
		));	
		$option_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` ORDER BY oid DESC;");
		foreach ($option_set_array as $key => $option_set) {			
			$option_set['title'] = "<a href=\"index.php?file=cpgmart/cpgmart_config&page=option_set&task=edit&id={$option_set['oid']}\">{$option_set['title']}</a>";
			$vars = array(
				'{CHECK_BOX}'	=>	HTMLelement::check_box("item_". $option_set['oid']),
				'{TITLE}'		=>	$option_set['title'],
				'{OPTION_SET}'	=>	HTMLelement::plain_option_list($option_set['option_array']),
			);
			if ($option_set['oid'] == $markup_element_id)
				echo cpgTemplate::set($element_m, $vars);
			else
				echo cpgTemplate::set($element, $vars);
		}
		// page nav
		echo cpgTemplate::set($page_nav, array(
			'{LANG_CHECK_ALL}'		=>	"CHECK ALL",	
			'{LANG_UNCHECK_ALL}'    =>  "UN CHECK ALL",
		));				
		endtable();		
	}	
// -----------------------------------------------------------------------------------------
// OPTION MANAGER
// ----------------------------------------------------------------------------------------- 	
	function option() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_option_manager;	
		// get ACTION		
		$task = cpgTool::request_var('task');		
		// TEMPLATE  
		$tpl_option = cpgTemplate::get('blog_option');
		$title     = cpgTemplate::extract($tpl_option, 'title');
		$element   = cpgTemplate::extract($tpl_option, 'element');
		$element_m = str_replace('tableb', 'tableh2', $element);
		$page_nav  = cpgTemplate::extract($tpl_option, 'page_nav');
		$control   = cpgTemplate::extract($tpl_option, 'control');
		$aoe 	   = cpgTemplate::extract($tpl_option, 'aoe');		
		$message   = cpgTemplate::get('element_message');  
	    // task -> action
		switch ($task) {
			case 'new':
				$vars = array(
					'{GB_TITLE}'		=>	"ADD NEW OPTION",
					'{ID}'				=>	"",
					'{TASK}'			=>	"new_act",
					'{LANG_TITLE}' 		 =>	"OPTION TITLE",
					'{TITLE}'		 	 =>	HTMLelement::text_input("title", ""),
					'{LANG_TITLE_ARRAY}' =>	"TITLE ( <u>it1</u>||<u>it2</u>||<u>it3</u> )",
					'{TITLE_ARRAY}'		 =>	HTMLelement::text_input("title_array", ""),
					'{LANG_VALUE_ARRAY}' =>	"VALUE ( <u>vl1</u>||<u>vl2</u>||<u>vl3</u> )",
					'{VALUE_ARRAY}'		 =>	HTMLelement::text_input("value_array", ""),
					'{LANG_CURRENCY}'	 =>	"CURRENCY",
					'{CURRENCY}'		 =>	HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgmart_currency']),
					'{LANG_SUBMIT}'		=>	'ADD',
					'{LANG_RESET}'		=>	'RESET',
				);
				echo cpgTemplate::set($aoe, $vars);
				HTMLelement::spacer();	
				break;
			case 'new_act':
				$title 		 = addslashes(cpgTool::post_var('title'));
				$title_array = cpgTool::encode_data(explode('||', cpgTool::post_var('title_array')));
				$value_array = explode('||', cpgTool::post_var('value_array'));
				$currency    = cpgTool::post_var('currency');
				foreach ($value_array as $key => $value) {
					$value_array[$key] = (float)$value;
				}
				$value_array = cpgTool::encode_data($value_array);
				cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CM_OPTION']}` (oid, title, title_array, value_array, currency) VALUES ('', '$title', '$title_array', '$value_array', '$currency');");				
				$markup_element_id = cpgDB::insertID();  
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, array('{MESSAGE}'	=>	"ADD OPTION <b><u>$title</u></b> SUCESSFUL !"));
				endtable();
				HTMLelement::spacer();
				break;
		    case 'edit':
		    	$id = (int)cpgTool::get_var('id');
				$current_option_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid = '$id' LIMIT 1;");				
				// little convert
				$current_option_data['title_array'] = implode("||", cpgTool::decode_data($current_option_data['title_array']));
				$current_option_data['value_array'] = implode("||", cpgTool::decode_data($current_option_data['value_array']));
				// vars
				$vars = array(
					'{GB_TITLE}'		 =>	"ADD NEW OPTION",
					'{ID}'				 =>	$id,
					'{TASK}'			 =>	"edit_act",
					'{LANG_TITLE}' 		 =>	"OPTION TITLE",
					'{TITLE}'		 	 =>	HTMLelement::text_input("title", $current_option_data['title']),
					'{LANG_TITLE_ARRAY}' =>	"TITLE (FORMAT: it1||it2||it3)",
					'{TITLE_ARRAY}'		 =>	HTMLelement::text_input("title_array", $current_option_data['title_array']),
					'{LANG_VALUE_ARRAY}' =>	"VALUE (FORMAT: vl1||vl2||vl3)",
					'{VALUE_ARRAY}'		 =>	HTMLelement::text_input("value_array", $current_option_data['value_array']),
					'{LANG_CURRENCY}'	 =>	"CURRENCY",
					'{CURRENCY}'		 =>	HTMLelement::simple_select("currency", $currency_symbol, $current_option_data['currency']),
					'{LANG_SUBMIT}'		 =>	'EDIT',
					'{LANG_RESET}'		 =>	'RESET',
				);
				echo cpgTemplate::set($aoe, $vars);
				HTMLelement::spacer();	
		    	break;
			case 'edit_act':
				$id 		 = (int)cpgTool::post_var('id');
				$title 		 = addslashes(cpgTool::post_var('title'));
				$title_array = cpgTool::encode_data(explode('||', cpgTool::post_var('title_array')));
				$value_array = explode('||', cpgTool::post_var('value_array'));
				$currency    = cpgTool::post_var('currency');
				foreach ($value_array as $key => $value) {
					$value_array[$key] = (float)$value;
				}
				$value_array = cpgTool::encode_data($value_array);
				cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CM_OPTION']}` SET title ='$title', title_array='$title_array', value_array='$value_array', currency='$currency' WHERE oid = '$id' LIMIT 1;");				
				$markup_element_id = $id;
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, array('{MESSAGE}'	=>	"EDIT OPTION <b><u>$title</u></b> SUCESSFUL !"));
				endtable();
				HTMLelement::spacer();
				break;
			case 'del_act':
				// which one will be delete
				foreach ($_POST as $name => $value) {
					if (cpgTool::in_string($name, "item_")) {
						$delete_id = (int)str_replace("item_", "", $name);
						if ($delete_id != 0 && $value == 'on') 
							$delete_list[] = $delete_id;
					}			
				}				
				// delete
				// success message  					
				starttable('-1','MESSAGE');
				foreach ($delete_list as $delete_id) {
					cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid = '$delete_id' LIMIT 1;");
					$vars = array('{MESSAGE}'	=>	"OPTION ID <b><u>$delete_id</u></b> DELETE SUCCESSFUL !");
					echo cpgTemplate::set($message, $vars);
				}                                       				
				endtable();
				HTMLelement::spacer();	
				break;	
				break;
		}
		// main page
		starttable('-1', 'OPTION LIST', 4);
		// control box
		echo cpgTemplate::set($control, array(
			'{LANG_NEW}'	=>	"NEW OPTION SET",
			'{LANG_DEL}'	=>	"DEL OPTION SET",
		));		
		// title
		echo cpgTemplate::set($title, array(
			'{LANG_TITLE}'		=>	"OPTION NAME",
			'{LANG_DATA}'		=>	"OPTION DATA",		
			'{LANG_CURRENCY}'	=>	"OPTION CURRENCY",		
		));	
		$option_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_OPTION']}` ORDER BY oid DESC;");
		foreach ($option_array as $key => $option) {			
			$option['title'] = "<a href=\"index.php?file=cpgmart/cpgmart_config&page=option&task=edit&id={$option['oid']}\">{$option['title']}</a>";			
			$option['title_array'] = cpgTool::decode_data($option['title_array']);
			$option['value_array'] = cpgTool::decode_data($option['value_array']);
			$combine_array = array_combine($option['title_array'], $option['value_array']);			
			$vars = array(
				'{CHECK_BOX}'	=>	HTMLelement::check_box("item_". $option['oid']),
				'{TITLE}'		=>	$option['title'],
				'{DATA}'		=>	HTMLelement::plain_option($combine_array),
				'{CURRENCY}'	=>	$currency_symbol[$option['currency']],	
			);
			if ($option['oid'] == $markup_element_id)
				echo cpgTemplate::set($element_m, $vars);
			else
				echo cpgTemplate::set($element, $vars);
		}
		// page nav
		echo cpgTemplate::set($page_nav, array(
			'{LANG_CHECK_ALL}'		=>	"CHECK ALL",	
			'{LANG_UNCHECK_ALL}'    =>  "UN CHECK ALL",
		));				
		endtable();		
	}
// -----------------------------------------------------------------------------------------
// PRICE SET MANAGER
// ----------------------------------------------------------------------------------------- 	
	function price_set() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_price_set_manager;
	    // get ACTION		
		$task = cpgTool::request_var('task');		
		// TEMPLATE  
		$tpl_price_set = cpgTemplate::get('blog_price_set');
		$title     = cpgTemplate::extract($tpl_price_set, 'title');
		$element   = cpgTemplate::extract($tpl_price_set, 'element');
		$element_m = str_replace('tableb', 'tableh2', $element);
		$page_nav  = cpgTemplate::extract($tpl_price_set, 'page_nav');
		$control   = cpgTemplate::extract($tpl_price_set, 'control');
		$aoe 	   = cpgTemplate::extract($tpl_price_set, 'aoe');
		$message   = cpgTemplate::get('element_message');  		 
	    // task -> action
		switch ($task) {
	    	case 'new':
	    		// get a price list
	    		$rowset = cpgDB::fetchRowset("SELECT pid, title, value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` ORDER BY title ASC;");
	    		$price_array = array();
	    		foreach ($rowset as $row) {
	    			$price_array[$row['pid']]	= "{$row['title']} {$currency_symbol[$row['currency']]} ({$row['title']})";
				}	    	
	    		// vars
	    		$vars = array(
	    			'{GB_TITLE}'		=>	"ADD NEW PRICE SET",
					'{ID}'				=>	"",
					'{TASK}'			=>	"new_act",
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title",""),
					'{LANG_PRICE_SET}'	=>	"PRICE SET",
					'{PRICE_SET}'		=>	HTMLelement::multiple_select('price_set', $price_array),
					'{LANG_SUBMIT}'		=>	'ADD',
					'{LANG_RESET}'		=>	'RESET',
	    		);
	    		echo cpgTemplate::set($aoe, $vars);
	    		HTMLelement::spacer();		    	
	    		break;
	    	case 'new_act':
	    	    $title = addslashes(cpgTool::post_var('title'));
	    	    $price_set = cpgTool::encode_data(cpgTool::post_var('price_set'));
	    	    $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CM_PRICESET']}` (pid, title, price_array) VALUES ('', '$title', '$price_set');");
				$markup_element_id = $pid;
				// success message 
				$vars = array('{MESSAGE}'	=>	"ADD PRICE SET <b><u>$title</u></b> SUCESSFUL !");
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, $vars);
				endtable();
				HTMLelement::spacer();     
	    		break;	
	    	case 'edit':
	    		$id = (int)cpgTool::get_var('id');
	    		$current_price_set_data = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CM_PRICESET']}` WHERE pid='$id';");
	    		$current_price_array = cpgTool::decode_data($current_price_set_data['price_array']);	    		
	    		// get a price list
	    		$rowset = cpgDB::fetchRowset("SELECT pid, title, value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` ORDER BY title ASC;");
	    		$price_array = array();
	    		$default_array = array();
	    		foreach ($rowset as $row) {
	    			$price_array[$row['pid']]	= "{$row['title']} {$currency_symbol[$row['currency']]} ({$row['title']})";
	    			if (in_array($row['pid'], $current_price_array)) $default_array[] = $row['pid'];	    			
				}	    	
	    		// vars
	    		$vars = array(
	    			'{GB_TITLE}'		=>	"EDIT A PRICE SET",
					'{ID}'				=>	$id,
					'{TASK}'			=>	"edit_act",
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title", $current_price_set_data['title']),
					'{LANG_PRICE_SET}'	=>	"PRICE SET",
					'{PRICE_SET}'		=>	HTMLelement::multiple_select('price_set', $price_array, $default_array),
					'{LANG_SUBMIT}'		=>	'EDIT',
					'{LANG_RESET}'		=>	'RESET',
	    		);
	    	    echo cpgTemplate::set($aoe, $vars);
	    		HTMLelement::spacer();	
	    		break;
	    	case 'edit_act':
	    		$id = (int)cpgTool::post_var('id');
	    		$title = addslashes(cpgTool::post_var('title'));
	    	    $price_set = cpgTool::encode_data(cpgTool::post_var('price_set'));
	    	    $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CM_PRICESET']}` SET title='$title', price_array='$price_set' WHERE pid = '$id';");
				$markup_element_id = $id;
				// success message 
				$vars = array('{MESSAGE}'	=>	"EDIT PRICE SET <b><u>$title</u></b> SUCESSFUL !");
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, $vars);
				endtable();
				HTMLelement::spacer();     
	    		break;	
	    		break;	
	    	case 'del_act':
	    		// which one will be delete
				foreach ($_POST as $name => $value) {
					if (cpgTool::in_string($name, "item_")) {
						$delete_id = (int)str_replace("item_", "", $name);
						if ($delete_id != 0 && $value == 'on') 
							$delete_list[] = $delete_id;
					}			
				}				
				// delete
				// success message  					
				starttable('-1','MESSAGE');
				foreach ($delete_list as $delete_id) {
					cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CM_PRICESET']}` WHERE pid = '$delete_id' LIMIT 1;");
					$vars = array('{MESSAGE}'	=>	"PRICE SET ID <b><u>$delete_id</u></b> deleted successful !");
					echo cpgTemplate::set($message, $vars);
				}                                       				
				endtable();
				HTMLelement::spacer();	
				break;	
		}
		// main page
		starttable('-1', 'PRICE SET LIST', 3);
		// control box
		echo cpgTemplate::set($control, array(
			'{LANG_NEW}'	=>	"NEW PRICE SET",
			'{LANG_DEL}'	=>	"DEL PRICE SET",
		));		
		// title
		echo cpgTemplate::set($title, array(
			'{LANG_TITLE}'		=>	"PRICE SET NAME",
			'{LANG_PRICE_SET}'	=>	"PRICE SET DATA",		
		));	
		$price_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_PRICESET']}` ORDER BY pid DESC;");
		foreach ($price_set_array as $key => $price_set) {			
			$price_set['title'] = "<a href=\"index.php?file=cpgmart/cpgmart_config&page=price_set&task=edit&id={$price_set['pid']}\">{$price_set['title']}</a>";
			$vars = array(
				'{CHECK_BOX}'	=>	HTMLelement::check_box("item_".$price_set['pid']),
				'{TITLE}'		=>	$price_set['title'],
				'{PRICE_SET}'	=>	HTMLelement::plain_price_list($price_set['price_array']),
			);
			if ($price_set['pid'] == $markup_element_id)
				echo cpgTemplate::set($element, $vars);
			else
				echo cpgTemplate::set($element, $vars);
		}
		// page nav
		echo cpgTemplate::set($page_nav, array(
			'{LANG_CHECK_ALL}'		=>	"CHECK ALL",	
			'{LANG_UNCHECK_ALL}'    =>  "UN CHECK ALL",
		));			
		endtable();		
	}	
// -----------------------------------------------------------------------------------------
// PRICE MANAGER
// ----------------------------------------------------------------------------------------- 	
	function price() {
		global $CONFIG;
		global $currency_symbol;
		global $lang_price_manager;
		// get ACTION		
		$task = cpgTool::request_var('task');                      				
		// TEMPLATE
		$tpl_price = cpgTemplate::get('blog_price');
		$title     = cpgTemplate::extract($tpl_price, 'title');
		$element   = cpgTemplate::extract($tpl_price, 'element');
		$element_m = str_replace('tableb', 'tableh2', $element);
		$page_nav  = cpgTemplate::extract($tpl_price, 'page_nav');
		$control   = cpgTemplate::extract($tpl_price, 'control');
		$aoe 	   = cpgTemplate::extract($tpl_price, 'aoe');
		$message   = cpgTemplate::get('element_message');  		
		// task -> action
		switch ($task) {
			// add new price
			case 'new':
				$vars = array(
					'{GB_TITLE}'		=>	"ADD NEW PRICE",
					'{ID}'				=>	"",
					'{TASK}'			=>	"new_act",
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title",""),
					'{LANG_VALUE}'		=>	"PRICE",
					'{VALUE}'			=>	HTMLelement::text_input("value",""),
					'{LANG_CURRENCY}'	=>	"CURRENCY",
					'{CURRENCY}'		=>	HTMLelement::simple_select("currency", $currency_symbol, $CONFIG['cpgmart_currency']),			    		    		
					'{LANG_SUBMIT}'		=>	'ADD',
					'{LANG_RESET}'		=>	'RESET',
				);
				echo cpgTemplate::set($aoe, $vars);
				HTMLelement::spacer();					
				break;
			// add a new price
			case 'new_act':
            	$title = addslashes(cpgTool::post_var('title'));
			    $value = cpgTool::price_format(cpgTool::post_var('value'));
			    $currency = addslashes(cpgTool::post_var('currency'));
			    $result = cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CM_PRICE']}` (pid, title, value, currency) VALUES ('', '$title', '$value', '$currency');");					
			    $markup_element_id = cpgDB::insertID();
				// success message
				$vars = array('{MESSAGE}'	=>	"ADD NEW PRICE NAME <b><u>$title</u></b> WITH VALUE of $currency <b><u>$value</u></b> SUCESSFUL !");
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, $vars);
				endtable();
				HTMLelement::spacer();
				break;			    
			case 'edit':
				// id = ?
				$id = (int)cpgTool::get_var('id'); 
			    $current_price_data = cpgDB::fetchRow("SELECT pid, title, value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid = '$id' LIMIT 1;");
			    // no data
			    if (!is_array($current_price_data)) cpgTool::error("Invaild ID !");			    
				// get current data			
				$vars = array(
					'{GB_TITLE}'		=>	"EDIT A PRICE",
					'{ID}'				=>	$id,
					'{TASK}'			=>	"edit_price_act",    
					'{LANG_TITLE}'		=>	"TITLE",
					'{TITLE}'			=>	HTMLelement::text_input("title", $current_price_data['title']),
					'{LANG_VALUE}'		=>	"PRICE",
					'{VALUE}'			=>	HTMLelement::text_input("value", $current_price_data['value']),
					'{LANG_CURRENCY}'	=>	"CURRENCY",
					'{CURRENCY}'		=>	HTMLelement::simple_select("currency", $currency_symbol, $current_price_data['currency']),			
					'{LANG_SUBMIT}'		=>	'MODIFY',
					'{LANG_RESET}'		=>	'RESET',
				);
				echo cpgTemplate::set($aoe, $vars);
				HTMLelement::spacer();
				break;
			case 'edit_act':				
				$id 	  = (int)cpgTool::post_var('id');
			    $title 	  = addslashes(cpgTool::post_var('title'));
			    $value    = cpgTool::price_format(cpgTool::post_var('value'));
			    $currency = addslashes(cpgTool::post_var('currency'));
			    $result = cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_CM_PRICE']}` SET title='$title', value='$value', currency='$currency' WHERE pid = '$pid';");
				$markup_element_id = $id;
				// success message 
				$vars = array('{MESSAGE}'	=>	"EDIT PRICE NAME <b><u>$title</u></b> WITH VALUE of $currency <b><u>$value</u></b> SUCESSFUL !");
				starttable('-1','MESSAGE');
				echo cpgTemplate::set($message, $vars);
				endtable();
				HTMLelement::spacer();
				break;
			case 'del_act':
				// which one will be delete
				foreach ($_POST as $name => $value) {
					if (cpgTool::in_string($name, "item_")) {
						$delete_id = (int)str_replace("item_", "", $name);
						if ($delete_id != 0 && $value == 'on') 
							$delete_list[] = $delete_id;
					}			
				}				
				// delete
				// success message  					
				starttable('-1','MESSAGE');
				foreach ($delete_list as $delete_id) {
					cpgDB::runQuery("DELETE FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid = '$delete_id' LIMIT 1;");
					$vars = array('{MESSAGE}'	=>	"PRICE ID <b><u>$delete_id</u></b> deleted successful !");
					echo cpgTemplate::set($message, $vars);
				}                                       				
				endtable();
				HTMLelement::spacer();	
				break;	
		}		
		// starttable
		starttable('-1', 'PRICE LIST', 4);
		// control box
		echo cpgTemplate::set($control, array(
			'{LANG_NEW}'	=>	"NEW PRICE",
			'{LANG_DEL}'	=>	"DEL PRICE",
		));		
		// title
		echo cpgTemplate::set($title, array(
			'{LANG_TITLE}'		=>	"PRICE NAME",
			'{LANG_VALUE}'		=>	"PRICE VALUE",		
			'{LANG_CURRENCY}'	=>	"PRICE CURRENCY",		
		));			
		// price list
		$price_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_PRICE']}` ORDER BY pid DESC;");
		foreach ($price_array as $price) {
			$price['title'] = "<a href=\"index.php?file=cpgmart/cpgmart_config&page=price&task=edit_price&id={$price['pid']}\">{$price['title']}</a>";
			$vars = array(
				'{CHECK_BOX}'	=>	HTMLelement::check_box("item_".$price['pid']),
				'{TITLE}'		=>	$price['title'],
				'{VALUE}'		=>	cpgTool::price_format($price['value']),
				'{CURRENCY}'	=>	$currency_symbol[$price['currency']],			
			);
			if ($price['pid'] == $markup_element_id)
				echo cpgTemplate::set($element, $vars);
			else
				echo cpgTemplate::set($element, $vars);
		}
		// page nav
		echo cpgTemplate::set($page_nav, array(
			'{LANG_CHECK_ALL}'		=>	"CHECK ALL",	
			'{LANG_UNCHECK_ALL}'    =>  "UN CHECK ALL",
		));		                           
		endtable();
	}
// -----------------------------------------------------------------------------------------
// EDIT ONE PIC
// -----------------------------------------------------------------------------------------			
	function edit_pic() {
		global $CONFIG;		
		$current_pic_data = cpgTool::get_pic_data($pid);
	    $tpl_edit_one_pic = cpgTemplate::get("blog_edit_pic");
	    $begin_form = cpgTemplate::extract($tpl_edit_one_pic, "begin_form");
	    $paoa 		= cpgTemplate::extract($tpl_edit_one_pic, "paoa");	    
	    $end_form 	= cpgTemplate::extract($tpl_edit_one_pic, "end_form");	
		$message    = cpgTemplate::get('element_message');				
		$task = cpgTool::request_var('task');
		$pid  = (int)cpgTool::get_var('pid');
		$aid  = (int)cpgTool::get_var('aid');
		// error if aid & pid = 0
		if ($aid == 0 && $pid == 0) {
			cpg_error(ERROR, 'PARAM ?');	
		}		
		if ($task == "edit_act") {
	    	$pid_array = cpgTool::post_var('pid_array');
	    	foreach ($pid_array as $pid) {
	    		if (cpgTool::post_var('pic_'.$pid) == "on") {
	    	    	$price  = cpgTool::post_var("price_".$pid);
	    		    $option = cpgTool::post_var("option_".$pid);
	    		    cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='$price', `option`='$option' WHERE pid='$pid';");	    	
				} else {					
					cpgDB::runQuery("UPDATE `{$CONFIG['TABLE_PICTURES']}` SET price='0', `option`='0' WHERE pid='$pid';");
				}
			}
			starttable('-1', 'MESSAGE');
			echo cpgTemplate::set($message, array(
				'{MESSAGE}'	=>	'EDIT CONFIG SUCCESSFUL !',
			));
			endtable();	
			HTMLelement::spacer();
		}		
		
		// get the pic data
		if ($aid != 0) {
			$pic_data_array = cpgDB::fetchRowset("SELECT pid, url_prefix, filename, filepath, price, `option`, pwidth, pheight, filesize, hits, votes FROM `{$CONFIG['TABLE_PICTURES']}` WHERE aid = '$aid';");		
			$action = "index.php?file=cpgmart/cpgmart_edit_pic&aid=".$aid;
		} elseif ($pid != 0) {
			$pic_data_array = cpgDB::fetchRowset("SELECT pid, url_prefix, filename, filepath, price, `option`, pwidth, pheight, filesize, hits, votes FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid = '$pid';");  	
			$action = "index.php?file=cpgmart/cpgmart_edit_pic&pid=".$pid;
		}	    
		
		starttable('-1',"EDIT PIC'S PRICE & OPTION", 3);
		// begin form
	    echo cpgTemplate::set($begin_form, array(   
	    	'{ACTION}'	=>	$action,	    	
	    ));
	    // body
	    foreach ($pic_data_array as $pic_data) {
	    	$pic_data['filesize'] = ceil($pic_data['filesize'] / 1024 );
	    	if ((int)$pic_data['price'] != 0) $checked = " checked=\"checked\""; else $checked = "";
	    	echo cpgTemplate::set($paoa, array(
	    		'{CHECKED}'		   => $checked,
	    	    '{PID}'	    	   => $pic_data['pid'],	    		 	    
	    		'{FILENAME}'	   => $pic_data['filename'],
	    		'{THUMB}'		   => HTMLelement::image(get_pic_url($pic_data, "thumb")),
	    		'{LANG_FILE_INFO}' => "FILE INFO",
	    		'{FILE_INFO}'	   => "{$pic_data['pwidth']} × {$pic_data['pheight']} - {$pic_data['filesize']} KB - {$pic_data['hits']} views - {$pic_data['votes']} votes",
	    		'{LANG_PRICE}' 	   => "PRICE",
	    		'{PRICE}'		   => HTMLelement::price_set_list ('price_' .$pic_data['pid'], $pic_data['price']),
	    		'{LANG_OPTION}'    => "OPTION",
	    		'{OPTION}'		   => HTMLelement::option_set_list('option_'.$pic_data['pid'], $pic_data['option']),
	    	));
		}
	    // end form
	    echo cpgTemplate::set($end_form, array(   
	    	'{LANG_SUBMIT}'	=>	"SUBMIT",
	    ));
	    endtable();
	}
// -----------------------------------------------------------------------------------------
// PROCESS
// -----------------------------------------------------------------------------------------		
	function proccess() {
		global $CONFIG;
		global $cpgmart;
		if (!is_object($cpgmart)) $cpgmart = new cpgMart();
		// read the post from PayPal system and add 'cmd'
		$req = 'cmd=_notify-validate';
		foreach ($_POST as $key => $value) {
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";			
		}
		// post back to PayPal system to validate
		$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		
		if ($CONFIG['cpgmart_test_mode'])
			$paypal_address = "www.sandbox.paypal.com";
		else
			$paypal_address = "www.paypal.com";
					
		$fp = fsockopen ($paypal_address, 80, $errno, $errstr, 30);
		if (!$fp) {
			self::process_html_error();
			// HTTP ERROR
		} else {
			fputs($fp, $header . $req);
			$content = "";
		    while (!feof($fp)) $content .= fgets ($fp, 1024);
		    // CART STATUS
			if     (strpos($content, "VERIFIED") !== false) $status = "VERIFIED";
			elseif (strpos($content, "INVALID")  !== false) $status = "INVALID";
			else   $status = "UNKNOW";		
			if ($status != "UNKNOW") {
				// txn ID
				$txn_id = $_POST['txn_id'];
				if ($txn_id != "") {
					// check if already exists
					$exists = cpgDB::fetchVar("SELECT count(oid) FROM `{$CONFIG['TABLE_CM_ORDER']}` WHERE txnid='$txn_id';");
					if ($exists == 0) {
						// add to DB	    	
		    			cpgDB::runQuery("INSERT INTO `{$CONFIG['TABLE_CM_ORDER']}` 
		    			(oid, txnid, user_id, user_name, cart, profile, time, status, method, log, note)
		    			VALUES
		    			('','$txn_id','".USER_ID."', '".USER_NAME."', '".cpgTool::encode_data($cpgmart->cart)."','','".time()."', '$status', 'PAYPAL', '".cpgTool::encode_data($_POST)."', '');");    			    		
		    			// flush cart
		    			$cpgmart->flush();		    		
		    		}
				}                                       
			}
		}
	}

	function process_html_error() {
		global $CONFIG;
		// do smt ???		
	}	
// -----------------------------------------------------------------------------------------
// THANK YOU
// -----------------------------------------------------------------------------------------		
	function thank_you() {
		global $CONFIG;		
		$message = cpgTemplate::get("element_message"); 
		// get the cart id		
		// show some thing to recognize		
		// success messaga
		starttable('-1', "MESSAGE");
		echo cpgTemplate::set($message, array(
			'{MESSAGE}'	=>	"YOU ARE SUCCESS TO MAKE A PAYMENT...",		
		));			
		endtable();
	}	
// -----------------------------------------------------------------------------------------
// MISC
// -----------------------------------------------------------------------------------------				
	// special function
	// 1. make a panel
	function a_panel($button_array) {
		starttable();
		endtable();
	}	 
	// 2. make a proccess table
	function a_P_table() {
		starttable();		
		endtable();
	}
	// 3. make a button table
	function a_B_table() {
		starttable();		
		endtable();				
	}
}

// all HTML element come form here

class HTMLelement {	
	// use in many case so I put it here
	function preview_cart($cart_data) {
		global $CONFIG;			
		global $currency_symbol;
		$tpl_preview_cart = cpgTemplate::get('blog_preview_cart');
	    $cart_header      = cpgTemplate::extract($tpl_preview_cart, 'cart_header');
	    $cart_element     = cpgTemplate::extract($tpl_preview_cart, 'cart_element');
	    $cart_footer      = cpgTemplate::extract($tpl_preview_cart, 'cart_footer');	    
		// cart header
		echo cpgTemplate::set($cart_header, array(
			'{LANG_THUMB}'			=>	"THUMB",
			'{LANG_NAME}'           =>	"ITEM NAME",
			'{LANG_PRICE_OPTION}'   =>	"PRICE & OPTION",
			'{LANG_PRICE_EACH}'     =>	"PRICE PER ONE",
			'{LANG_QTY}'            =>	"QTY",
			'{LANG_PRICE_ALL}'      =>	"PRICE ALL",		
		));
		// cart element
		$total = 0;	
		foreach ($cart_data as $item_pos => $item_data) {
			$CURRENT_PIC_DATA = cpgTool::get_pic_data($item_data['pid']);
			$price_each = cpgTool::price_each($item_data);  			
			$total += $price_each * $item_data['qty'];	
			echo cpgTemplate::set($cart_element, array(
				'{THUMB}'		=>	HTMLelement::image(get_pic_url($CURRENT_PIC_DATA, "thumb")),
				'{NAME}'        =>	HTMLelement::item_name($CURRENT_PIC_DATA),
				'{PRICE}'       =>	HTMLelement::item_price_list($item_data['price']),
				'{OPTION}'  	=>	HTMLelement::item_option_list($item_data['option']),
				'{PRICE_EACH}'  =>	$currency_symbol[$CONFIG['cpgmart_currency']] ." ".cpgTool::price_format($price_each),
				'{QTY}'         =>	$item_data['qty'],
				'{PRICE_ALL}'	=>	$currency_symbol[$CONFIG['cpgmart_currency']] ." ".cpgTool::price_format($price_each * $item_data['qty']),						
			));
		}
		// cart footer
		echo cpgTemplate::set($cart_footer, array(
			'{LANG_PRICE_TOTAL}'	=>	"TOTAL PRICE",
			'{PRICE_TOTAL}'			=>	$currency_symbol[$CONFIG['cpgmart_currency']] ." ".cpgTool::price_format($total),		
		));
	}	
	function hidden($name, $value) {
		return "<input type=\"hidden\" name=\"$name\" value=\"$value\" />\n";		
	}
	function radio($name, $value="") {
		switch ($value) {
			case 1:
				return "<input type=\"radio\" name=\"$name\" value=\"1\" checked=\"checked\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" /> N\n";	
				break;
			case 0:
				return "<input type=\"radio\" name=\"$name\" value=\"1\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" checked=\"checked\" /> N\n";	
				break;
			default:	
				return "<input type=\"radio\" name=\"$name\" value=\"1\"> Y<input type=\"radio\" name=\"$name\" value=\"0\" /> N\n";	
		}
	}
	function qty_input($name, $value="") {
		return "<input class=\"textinput\" type=\"text\" name=\"$name\" size=\"3\" value=\"$value\" />\n";			
	}
	function text_input($name, $value="") {
		return "<input class=\"textinput\" type=\"text\" name=\"$name\" style=\"width: 100%\" value=\"$value\" />\n";	
	}
	function simple_select($name, $value_array, $default='') {
		global $CONFIG;
		$html = "";
		$html .= "<select name=\"$name\" class=\"listbox\" style=\"width: 100%;\">\n";
		foreach ($value_array as $key => $title) {
			if ($key == $default)
				$html .= "<option value=\"$key\" selected=\"selected\">$title</option>\n";
			else
				$html .= "<option value=\"$key\">$title</option>\n";
		}
		$html .= "</select>\n";
		return $html;
	}
	function advance_select($name, $value_array, $default='') {
		global $CONFIG;
		$html = "";
		$html .= "<select name=\"$name\" class=\"listbox\" style=\"width: 100%;\">\n";
		foreach ($value_array as $id => $data) {
			// different in currency ?
			// format
			$data[0] = cpgTool::price_format(cpgTool::to_config_currency($data[0], $data[2]));
			if ($id == $default)
				$html .= "<option value=\"$id\" selected=\"selected\">{$data[0]} {$CONFIG['cpgmart_currency']} ({$data[1]})</option>\n";
			else
				$html .= "<option value=\"$id\">{$data[0]} {$CONFIG['cpgmart_currency']} ({$data[1]})</option>\n";
		}
		$html .= "</select>\n";
		return $html;
	}
	function multiple_select($name, $value_array, $default=array(), $size=5) {
		global $CONFIG;
		$html = "";	
		$html .= "<select name=\"{$name}[]\" class=\"listbox\" multiple=\"multiple\" size=\"$size\" style=\"width: 100%;\">\n"; 
		foreach ($value_array as $value => $title) {
			if (in_array($value, $default)) 
				$html .= "<option value=\"$value\" selected=\"selected\">$title</option>\n";
			else 	
				$html .= "<option value=\"$value\">$title</option>\n";			
		}		
		$html .= "</select>\n";
		return $html;
	}	
	function check_box($name) {
		return "<input type=\"checkbox\" name=\"$name\">\n";	
	}	
	function price_list($id, $default="", $extra="") {
		global $CONFIG;
		$id = (int)$id;                                                		
		$price_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CM_PRICESET']}` WHERE pid = '$id' LIMIT 1;");
		$price_array = cpgTool::decode_data($price_set['price_array']);
		foreach ($price_array as $price_id) { 
			$price_data = cpgDB::fetchRow("SELECT pid, title, value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid = '{$price_id}' LIMIT 1;");								
			$price_combine[$price_data['pid']] =  array($price_data['value'], $price_data['title'], $price_data['currency']);
			
		}
		return self::advance_select('price'.$extra, $price_combine, $default);
	}
	function option_list($id, $default_array=array(), $extra="") {
		global $CONFIG;
		$id = (int)$id;
		$html = "";
		$option_set = cpgDB::fetchRow("SELECT * FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` WHERE oid = '$id' LIMIT 1;");
		$option_array = cpgTool::decode_data($option_set['option_array']);			
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";		
		foreach($option_array as $option_id) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");
			$option_data['title_array']	= cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array']	= cpgTool::decode_data($option_data['value_array']);			
			foreach ($option_data['title_array'] as $title_key => $title_value) {
				$option_combine[] = array($option_data['value_array'][$title_key],$option_data['title_array'][$title_key], $option_data['currency']);			
			}
			$html .= "<tr>\n<td class=\"tableh2\" valign=\"middle\" style=\"text-align: right;\">{$option_data['title']}&nbsp;</td>\n<td class=\"tableb\">".self::advance_select("option_".$option_id.$extra, $option_combine, $default_array[$option_id])."</td>\n</tr>\n";  						
		}					
		$html .= "</table>\n";
		return $html;
	}
	function plain_price_list($price_id_array) {
		global $CONFIG;
		if (!is_array($price_id_array)) $price_id_array = cpgTool::decode_data($price_id_array);
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($price_id_array as $price_id) {
			$price_data = cpgDB::fetchRow("SELECT title, value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid='$price_id';");
			$html .= "<tr>\n<td class=\"tableh1\" valign=\"middle\" width=\"20%\">{$price_data['title']}&nbsp;</td>\n<td class=\"tableb\" width=\"70%\">{$price_data['value']}</td>\n<td class=\"tableb\" width=\"10%\">{$price_data['currency']}</td>\n</tr>\n"; 					
		}		
		$html .= "</table>\n";
		return $html;
	}
	function plain_option_list($option_id_array) {
		global $CONFIG;
		if (!is_array($option_id_array)) $option_id_array = cpgTool::decode_data($option_id_array);
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";
		foreach ($option_id_array as $option_id) {
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array, currency FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid='$option_id';");	
			$option_data['title_array'] = cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array'] = cpgTool::decode_data($option_data['value_array']);
			$combine_array = array_combine($option_data['title_array'], $option_data['value_array']);
			$sub_html = self::plain_option($combine_array);
			$html .= "<tr>\n<td class=\"tableh1\" valign=\"middle\" width=\"30%\" align=\"center\">{$option_data['title']}&nbsp;</td>\n<td class=\"tableb\" width=\"60%\">$sub_html</td>\n<td class=\"tableb\" width=\"10%\" align=\"center\">{$option_data['currency']}</td>\n</tr>\n";						
		}
		$html .= "</table>\n";
		return $html;
	}
	function plain_option($combine_array) {
		$sub_html = "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";		
		foreach ($combine_array as $title => $value) {
			$value = cpgTool::price_format($value);
			$sub_html .= "<tr>\n<td class=\"tableh2\" width=\"40%\">$title</td>\n<td class=\"tableb\" width=\"60%\">$value</td>\n</tr>\n";
		}		
		$sub_html .= "</table>\n";
		return $sub_html;
	}
	function price_list_title($id) {
		global $CONFIG;  
		$id = (int)$id;		
		return cpgDB::fetchVar("SELECT title FROM `{$CONFIG['TABLE_CM_PRICESET']}` WHERE pid = '$id' LIMIT 1;");
	}		
	function option_list_title($id) {
		global $CONFIG;  		
		$id = (int)$id;		
		return cpgDB::fetchVar("SELECT title FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` WHERE oid = '$id' LIMIT 1;");
	}
	function item_price_list($item_price) {
		global $CONFIG;
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";				
		$price_data = cpgDB::fetchRow("SELECT title, value, currency  FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid = '$item_price' LIMIT 1;");			
		$html .= "<tr>\n<td class=\"tableh2\" width=\"40%\">{$price_data['title']}</td>\n<td class=\"tableb\" width=\"60%\">{$price_data['value']}</td>\n</tr>\n";		
		$html .= "</table>\n";
		return $html;		
	}		
	function item_option_list($item_option) {
		global $CONFIG;
		$html = "";
		$html .= "<table class=\"maintable\" width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\">\n";		
		foreach ($item_option as $option_id => $option_value) {			
			$option_data = cpgDB::fetchRow("SELECT title, title_array, value_array FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid = '$option_id' LIMIT 1;");
			$option_data['title_array'] = cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array'] = cpgTool::decode_data($option_data['value_array']);
			foreach ($option_data['title_array'] as $title_key => $title_value) {
				$option_combine[] = array($option_data['value_array'][$title_key], $option_data['title_array'][$title_key]);			
			}			
			$html .= "<tr>\n<td class=\"tableh2\" width=\"40%\">{$option_data['title']}</td>\n<td class=\"tableb\" width=\"40%\">{$option_combine[$option_value][1]}</td>\n<td class=\"tableb\" width=\"20%\">{$option_combine[$option_value][0]}</td>\n</tr>\n";
		}			  
		$html .= "</table>\n";
		return $html;
	}
	function price_set_list($name, $default="") {
		global $CONFIG;		
		$price_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_PRICESET']}`;");
		$value_array = array();
		foreach ($price_set_array as $price_set) {
			$value_array[$price_set['pid']] = $price_set['title'];
		}			
		return self::simple_select($name, $value_array, $default);
	}
	function option_set_list($name, $default="") {
		global $CONFIG;
		$option_set_array = cpgDB::fetchRowset("SELECT * FROM `{$CONFIG['TABLE_CM_OPTIONSET']}`;");
		$value_array = array();
		foreach ($option_set_array as $option_set) {
			$value_array[$option_set['oid']] = $option_set['title'];
		}			
		return self::simple_select($name, $value_array, $default);
	}
	
	function spacer($height=10)	{
		echo "<img src=\"images/spacer.gif\" height=\"$height\" width=\"100%\">\n";	
	}
	function image($image_link, $size = 0.75) {		
		global $CONFIG;
		$image_info = getimagesize($image_link); 		
		$image_info[0] = round($image_info[0] * $size);
		$image_info[1] = round($image_info[1] * $size);
		if ((int)$image_info[0] == 0) $image_info[0] = $CONFIG['thumb_width'] * $size;
		if ((int)$image_info[1] == 0) $image_info[1] = $CONFIG['thumb_width'] * $size;
				
		return "<img class=\"image\" src=\"$image_link\" width=\"{$image_info[0]}\" height=\"{$image_info[1]}\">";		
	}	
	function link($link, $text, $class="") {
		if ($class)
			return "<a class=\"$class\" href=\"$link\">$text</a>";
		else
			return "<a href=\"$link\">$text</a>";
	}
	function item_name($CURRENT_PIC_DATA) {		
		return $CURRENT_PIC_DATA['pid']."|".$CURRENT_PIC_DATA['filename'];			
	}
}   

?>