<?php

class cpgTool { 
	// _REQUEST VAR
	function request_var($var_name) {
		return $_REQUEST[$var_name];	
	}                                   	
	// _GET VAR
	function get_var($var_name) {
		return $_REQUEST[$var_name];	
	}
	// _POST VAR
	function post_var($var_name) {
		return $_REQUEST[$var_name];	
	}	
	// format to cool format 
	function price_format($price) { 
		return number_format($price, 2, '.', '');	
	}
	// exchange price beetween different currecy
	function currency_exchange($price, $from, $to) {
		global $CONFIG;				
		return $price*(self::currency_rate($to)/self::currency_rate($from));		
	}
	// to config currency
	function to_config_currency($price, $currency) {
		global $CONFIG;		
		return self::currency_exchange($price, $currency, $CONFIG['cpgmart_currency']);		
	}	
	// check if this pic is shopable || not
	function is_shopable($pic_data) {
		global $CONFIG;	
		// pid || pic_data
		if (!is_array($pic_data)) $pic_data = array('pid'=>$pic_data);		
		// empty -> get from DB ^^
		if (!isset($pic_data['price']))
			$pic_data['price'] = cpgDB::fetchVar("SELECT price FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid = '{$pic_data['pid']}' LIMIT 1;");		
		// check & return
		if ((int)$pic_data['price'] == 0) return false; else return true;
	
	}                 	   
	// encode
	function encode_data($data) {
		return base64_encode(serialize($data));		
	}
	// decode
	function decode_data($data) {
		return unserialize(base64_decode($data));		
	}
	function add_js($file_or_content) {
		global $CONFIG;
		global $template_header;
		// file || content
		if (is_file($fileORcontent))
			$js_include = "<script type=\"text/javascript\" src=\"$file_or_content\"></script>";       
		else
			$js_include = $file_or_content;
		// add
		$template_header = str_replace("</head>",$js_include."\n</head>",$template_header);
	}
	function error($errorString) {
		echo $errorString;
		exit;		
	}
	function in_string($string, $search_string) {
		if (strpos($string, $search_string) !== false) return true;
		else return false;	
	}
	function get_pic_data($pid) {
		global $CONFIG;
		return cpgDB::fetchRow("SELECT pid, url_prefix, filepath, filename, `price`, `option` FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid='$pid' LIMIT 1;");		
	}
	function price_each($item_data) {
		global $CONFIG;		
		$total = 0;
		// get price value
		$current_price_data = cpgDB::fetchRow("SELECT value, currency FROM `{$CONFIG['TABLE_CM_PRICE']}` WHERE pid='{$item_data['price']}' LIMIT 1;");
		$total += self::to_config_currency($current_price_data['value'], $current_price_data['currency']);
		// get option value	
		foreach ($item_data['option'] as $option_id => $option_value) {
		 	$option_data = cpgDB::fetchRow("SELECT title_array, value_array, currency FROM `{$CONFIG['TABLE_CM_OPTION']}` WHERE oid='{$option_id}' LIMIT 1;");
		 	$option_data['title_array']	= cpgTool::decode_data($option_data['title_array']);
			$option_data['value_array']	= cpgTool::decode_data($option_data['value_array']);			
		 	foreach ($option_data['title_array'] as $title_key => $title_value) {
				$option_combine[] = array($option_data['value_array'][$title_key], $option_data['title_array'][$title_key]);			
			}
		 	$total += self::to_config_currency($option_combine[$option_value][0], $option_data['currency']);		 	
		}		
		return $total;
	}
	function get_option_array_from_pid($pid) {
		global $CONFIG; 	
		$option_set_id = cpgDB::fetchVar("SELECT `option` FROM `{$CONFIG['TABLE_PICTURES']}` WHERE pid='$pid' LIMIT 1;");		
		$option_array = cpgDB::fetchVar("SELECT option_array FROM `{$CONFIG['TABLE_CM_OPTIONSET']}` WHERE oid='$option_set_id' LIMIT 1;");
		return self::decode_data($option_array);
	}
	function currency_rate($currency) {
		$exc_rate = array(		
			'USD' => 1,
			'CAD' => 0.99597997037873,
			'GBP' => 0.4914309894915,
			'EUR' => 0.70526835460893,
			'JPY' => 115.34663939629,
		);
		return $exc_rate[$currency];
	} 
	function process() {
		global $CONFIG;
		// read the post from PayPal system and add 'cmd'
		$req = 'cmd=_notify-validate';
		foreach ($_POST as $key => $value) {
			$value = urlencode(stripslashes($value));
			$req .= "&$key=$value";
		}	
		// test mode ?
		if ($CONFIG['cpgmart_test_mode']) 
			$paypal_address = 'www.sandbox.paypal.com';	
		else
			$paypal_address = 'www.paypal.com';	
		// post back to PayPal system to validate
		$header = "POST /cgi-bin/webscr HTTP/1.0\r\n";
		$header .= "Content-Type: application/x-www-form-urlencoded\r\n";
		$header .= "Content-Length: " . strlen($req) . "\r\n\r\n";
		$fp = fsockopen ($paypal_address, 80, $errno, $errstr, 30);
		
		// assign posted variables to local variables
		$item_name = $_POST['item_name'];
		$business = $_POST['business'];
		$item_number = $_POST['item_number'];
		$payment_status = $_POST['payment_status'];
		$mc_gross = $_POST['mc_gross'];
		$payment_currency = $_POST['mc_currency'];
		$txn_id = $_POST['txn_id'];
		$receiver_email = $_POST['receiver_email'];
		$receiver_id = $_POST['receiver_id'];
		$quantity = $_POST['quantity'];
		$num_cart_items = $_POST['num_cart_items'];
		$payment_date = $_POST['payment_date'];
		$first_name = $_POST['first_name'];
		$last_name = $_POST['last_name'];
		$payment_type = $_POST['payment_type'];
		$payment_status = $_POST['payment_status'];
		$payment_gross = $_POST['payment_gross'];
		$payment_fee = $_POST['payment_fee'];
		$settle_amount = $_POST['settle_amount'];
		$memo = $_POST['memo'];
		$payer_email = $_POST['payer_email'];
		$txn_type = $_POST['txn_type'];
		$payer_status = $_POST['payer_status'];
		$address_street = $_POST['address_street'];
		$address_city = $_POST['address_city'];
		$address_state = $_POST['address_state'];
		$address_zip = $_POST['address_zip'];
		$address_country = $_POST['address_country'];
		$address_status = $_POST['address_status'];
		$item_number = $_POST['item_number'];
		$tax = $_POST['tax'];
		$option_name1 = $_POST['option_name1'];
		$option_selection1 = $_POST['option_selection1'];
		$option_name2 = $_POST['option_name2'];
		$option_selection2 = $_POST['option_selection2'];
		$for_auction = $_POST['for_auction'];
		$invoice = $_POST['invoice'];
		$custom = $_POST['custom'];
		$notify_version = $_POST['notify_version'];
		$verify_sign = $_POST['verify_sign'];
		$payer_business_name = $_POST['payer_business_name'];
		$payer_id =$_POST['payer_id'];
		$mc_currency = $_POST['mc_currency'];
		$mc_fee = $_POST['mc_fee'];
		$exchange_rate = $_POST['exchange_rate'];
		$settle_currency  = $_POST['settle_currency'];
		$parent_txn_id  = $_POST['parent_txn_id'];
		$pending_reason = $_POST['pending_reason'];
		$reason_code = $_POST['reason_code'];

	                                                            	
		
		
	    if (!$fp) {
	    	// HTML ERROR	
			cpgHTML::process_html_error();
		} else {
			// HTML OK			
			fputs ($fp, $header . $req);
			while (!feof($fp)) {
				$res = fgets ($fp, 1024);
				// VERIFIED ORDER
				if (strcmp ($res, "VERIFIED") == 0) {

					$fecha = date("m")."/".date("d")."/".date("Y");
					$fecha = date("Y").date("m").date("d");

					//check if transaction ID has been processed before
					$checkquery = "select txnid from paypal_payment_info where txnid='".$txn_id."'";
					$sihay = mysql_query($checkquery) or die("Duplicate txn id check query failed:<br>" . mysql_error() . "<br>" . mysql_errno());
					$nm = mysql_num_rows($sihay);
					if ($nm == 0){

					//execute query

    					if ($txn_type == "cart") {
    						$strQuery = "insert into paypal_payment_info(paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')";

     						$result = mysql_query($strQuery) or die("Cart - paypal_payment_info, Query failed:<br>" . mysql_error() . "<br>" . mysql_errno());
     						for ($i = 1; $i <= $num_cart_items; $i++) {
         						$itemname = "item_name".$i;
         						$itemnumber = "item_number".$i;
         						$on0 = "option_name1_".$i;
         						$os0 = "option_selection1_".$i;
         						$on1 = "option_name2_".$i;
         						$os1 = "option_selection2_".$i;
         						$quantity = "quantity".$i;

         						$struery = "insert into paypal_cart_info
         							(txnid, itemnumber, itemname, os0, on0, os1, on1, quantity, invoice, custom) 
         							VALUES 
         							('".$txn_id."','".$_POST[$itemnumber]."','".$_POST[$itemname]."','".$_POST[$on0]."','".$_POST[$os0]."','".$_POST[$on1]."','".$_POST[$os1]."','".$_POST[$quantity]."','".$invoice."','".$custom."')";
         						$result = mysql_query($struery) or die("Cart - paypal_cart_info, Query failed:<br>" . mysql_error() . "<br>" . mysql_errno());
     						}
    					} else {
    						// ??? - WHAT IS THIS ANY WAY ???
    						  						
    						
     						$strQuery = "insert into paypal_payment_info(paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,itemnumber,itemname,os0,on0,os1,on1,quantity,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$item_number."','".$item_name."','".$option_name1."','".$option_selection1."','".$option_name2."','".$option_selection2."','".$quantity."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')";
     						$result = mysql_query("insert into paypal_payment_info(paymentstatus,buyer_email,firstname,lastname,street,city,state,zipcode,country,mc_gross,mc_fee,itemnumber,itemname,os0,on0,os1,on1,quantity,memo,paymenttype,paymentdate,txnid,pendingreason,reasoncode,tax,datecreation) values ('".$payment_status."','".$payer_email."','".$first_name."','".$last_name."','".$address_street."','".$address_city."','".$address_state."','".$address_zip."','".$address_country."','".$mc_gross."','".$mc_fee."','".$item_number."','".$item_name."','".$option_name1."','".$option_selection1."','".$option_name2."','".$option_selection2."','".$quantity."','".$memo."','".$payment_type."','".$payment_date."','".$txn_id."','".$pending_reason."','".$reason_code."','".$tax."','".$fecha."')") or die("Default - paypal_payment_info, Query failed:<br>" . mysql_error() . "<br>" . mysql_errno());
    					}
    					// send an email in any case
 						echo "Verified";
     					mail($notify_email, "VERIFIED IPN", "$res\n $req\n $strQuery\n $struery\n  $strQuery2");
					} else {
						// send an email
						mail($notify_email, "VERIFIED DUPLICATED TRANSACTION", "$res\n $req \n $strQuery\n $struery\n  $strQuery2");
					}
				}
				// if the IPN POST was 'INVALID'...do this
				else if (strcmp ($res, "INVALID") == 0) {
					// log for manual investigation

					mail($notify_email, "INVALID IPN", "$res\n $req");
				}
			}
		fclose ($fp);
		}		        	
	}
}

?>