<?php

if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
include_once("include/init.inc.php");

// load language
if (!file_exists(CPGMART_PLUGIN_DIR."lang/{$CONFIG['lang']}.php")) $CONFIG['lang'] = 'english';
require_once(CPGMART_PLUGIN_DIR."lang/{$CONFIG['lang']}.php");

// control panel
pageheader(); 
HTMLelement::spacer();
starttable();
echo <<<EOT
<form name="config_form" action="index.php" method="GET">
<input type="hidden" name="file" value="cpgmart/cpgmart_config">
<input type="hidden" name="page" value="">
<tr>
	<td class="tableb" align="center">
		<input type="button" value="Home" class="button" onclick="document.config_form.page.value='main'; document.config_form.submit();">
		<input type="button" value="Config" class="button" onclick="document.config_form.page.value='config'; document.config_form.submit();">		
		<input type="button" value="Price Manager" class="button" onclick="document.config_form.page.value='price'; document.config_form.submit();">		
		<input type="button" value="Price Set Manager" class="button" onclick="document.config_form.page.value='price_set'; document.config_form.submit();">   	
    	<input type="button" value="Option Manager" class="button" onclick="document.config_form.page.value='option'; document.config_form.submit();">
    	<input type="button" value="Option Set Manager" class="button" onclick="document.config_form.page.value='option_set'; document.config_form.submit();">
    	<input type="button" value="Order Manager" class="button" onclick="document.config_form.page.value='order'; document.config_form.submit();">
    	<input type="button" value="Documents" class="button" onclick="document.config_form.page.value='documents'; document.config_form.submit();">
		<input type="button" value="Abouts" class="button" onclick="document.config_form.page.value='abouts'; document.config_form.submit();">   	
	<td>
</tr>
</form>
EOT;
endtable();

HTMLelement::spacer();

// Control var
$page = cpgTool::get_var('page');
$task = cpgTool::get_var('task');
// define action
switch ($page) {
	case 'config':          					
		cpgHTML::config();	
	    break;
	case 'price':	
		cpgHTML::price();
	    break;
	case 'price_set':    
		cpgHTML::price_set();
		break;
	case 'option':
		cpgHTML::option();
		break;
	case 'option_set':
		cpgHTML::option_set();
		break;				
	case 'order':
		cpgHTML::order();  
		break;
	case 'documents':
		cpgHTML::documents();
		break;	
	case 'abouts':
		cpgHTML::abouts(); 
		break;		
	case 'main':	
	default:	
		cpgHTML::mainpage();
}
pagefooter();
?>