<?php
 /*************************************************************
 * Shopping Cart Modules For Coppermine Photo Gallery v 1.4.x *
 **************************************************************
 * Mod Version: 1.0.0                                         *
 * $Source: /cpgmart/cpgmart.class.php                        *
 * $Revision: 1.0                                             *
 * $Author: foulu                                             *
 * $Email: kak@amfcvn.net                                     *
 * $Date: 2005/06/24 08:05:20                                 *  
 *************************************************************/
 
 // I think I will use cookie
 
 class cpgMart { 
 	// load from cookie 
 	function cpgMart() {
 		global $CONFIG;
 		if (isset($_COOKIE[$CONFIG['cookie_name'].'_cpgmart'])) { 		
 			$data = cpgTool::decode_data($_COOKIE[$CONFIG['cookie_name'].'_cpgmart']);
 			$this->cart = $data['cart']; 			
 			$this->profile = $data['profile']; 
		} else {
			$this->cart = array();
			$this->profile = array();
		}
	}
 	// add item to cart
 	function add_item($item_data) {
 		// check if item ID exists || or not
 		$check = false;
 		foreach ($this->cart as $key => $item) {
 			if ($item['pid'] == $item_data['pid'] && $item['price'] == $item_data['price'] && $item['option'] == $item_data['option']) {
 				$check = true;
 				// update because ...
 				$this->cart[$key]['qty']++;
			}
		}
		// add if false
		if (!$check) $this->cart[] = $item_data;
	}
	// modify an item
	function edit_item($item_pos, $item_data) {
		$this->cart[$item_pos] = $item_data;
	}
	// remove an item
	function remove_item($item_pos) {
		unset($this->cart[$item_pos]);
	}
 	// save to cookie
 	function save() {
 		global $CONFIG;
		$data['cart'] = $this->cart;
		$data['profile'] = $this->profile;
		$data = cpgTool::encode_data($data);		
        setcookie($CONFIG['cookie_name'].'_cpgmart', $data, time()+86400*30, $CONFIG['cookie_path']);
	}
	// save to database
	function save2DB() {
		global $CONFIG; 	
		// construct the query
		$query = "INSERT INTO `{$CONFIG['TABLE_XXX']}` (id, cart, profile, status) VALUES ('', '{$this->cart}', '{$this->profile}', 'XXX');";
	    cpgDB::runQuery($query);
	    // return the ID of newest item
	    return mysql_insert_id();
	}
	// flush the data
	function flush() {
		global $CONFIG;
	    unset($this->cart);
	    unset($this->profile);
	    setcookie($CONFIG['cookie_name'].'_cpgmart', "", time()-3600, $CONFIG['cookie_path']);
	}
}

?>